Index: /code/branches/newlevel2012/.project
===================================================================
--- /code/branches/newlevel2012/.project	(revision 9096)
+++ /code/branches/newlevel2012/.project	(revision 9096)
@@ -0,0 +1,11 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>Orxonox-Source@newlevel2012</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+	</buildSpec>
+	<natures>
+	</natures>
+</projectDescription>
Index: /code/branches/newlevel2012/data/levels/towerDefense.oxw
===================================================================
--- /code/branches/newlevel2012/data/levels/towerDefense.oxw	(revision 9096)
+++ /code/branches/newlevel2012/data/levels/towerDefense.oxw	(revision 9096)
@@ -0,0 +1,44 @@
+<LevelInfo
+ name = "Tower Defense"
+ description = "A level with not much in it."
+ tags = "test"
+ screenshot = "emptylevel.png"
+/>
+
+<?lua
+  include("stats.oxo")
+  include("HUDTemplates3.oxo")
+  include("templates/lodInformation.oxt")
+?>
+
+
+<?lua
+  include("templates/spaceshipAssff2.oxt")
+  include("templates/spaceshipPirate.oxt")
+?>
+
+
+<Level>
+  <templates>
+    <Template link=lodtemplate_default />
+  </templates>
+  <?lua include("includes/notifications.oxi") ?>
+
+
+  <Scene
+    ambientlight = "0.8, 0.8, 0.8"
+    skybox       = "Orxonox/Starbox"
+  >
+
+    <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0"/>
+    <SpawnPoint team=0 position="-200,0,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff2 />
+    
+	<StaticEntity position="0,0,0" direction="0,0,0" collistionType=static mass=100000>
+		<attached>
+			<Model position="0,0,0" mesh="Playfield_ME.mesh" scale3D="10,10,10" />
+		</attached>
+	</StaticEntity>
+
+  </Scene>
+</Level>
+
Index: /code/branches/newlevel2012/src/modules/towerdefense/Spielfeld Blender/OgreXMLConverter.log
===================================================================
--- /code/branches/newlevel2012/src/modules/towerdefense/Spielfeld Blender/OgreXMLConverter.log	(revision 9096)
+++ /code/branches/newlevel2012/src/modules/towerdefense/Spielfeld Blender/OgreXMLConverter.log	(revision 9096)
@@ -0,0 +1,31 @@
+15:38:46: Creating resource group General
+15:38:46: Creating resource group Internal
+15:38:46: Creating resource group Autodetect
+15:38:46: Registering ResourceManager for type Mesh
+15:38:46: Registering ResourceManager for type Material
+15:38:46: Registering ResourceManager for type Skeleton
+15:38:46: XMLMeshSerializer reading mesh data from /home/mentzerf/mentzerf-extra-0/newlevel2012/src/modules/towerdefense/Spielfeld Blender/Playfield_ME.mesh.xml...
+15:38:46: Reading submeshes...
+15:38:46: Reading geometry...
+15:38:46: Geometry done...
+15:38:46: Submeshes done.
+15:38:46: XMLMeshSerializer import successful.
+15:38:46: Reorganising vertex buffers to automatic layout..
+15:38:46: MeshSerializer writing mesh data to /home/mentzerf/mentzerf-extra-0/newlevel2012/src/modules/towerdefense/Spielfeld Blender/Playfield_ME.mesh...
+15:38:46: File header written.
+15:38:46: Writing mesh data...
+15:38:46: Writing submesh...
+15:38:46: Exporting submesh texture aliases...
+15:38:46: Submesh texture aliases exported.
+15:38:46: Submesh exported.
+15:38:46: Exporting bounds information....
+15:38:46: Bounds information exported.
+15:38:46: Exporting submesh name table...
+15:38:46: Submesh name table exported.
+15:38:46: Exporting edge lists...
+15:38:46: Edge lists exported
+15:38:46: Mesh data exported.
+15:38:46: MeshSerializer export successful.
+15:38:46: Unregistering ResourceManager for type Skeleton
+15:38:46: Unregistering ResourceManager for type Material
+15:38:46: Unregistering ResourceManager for type Mesh
Index: /code/branches/newlevel2012/src/modules/towerdefense/Spielfeld Blender/Playfield.material
===================================================================
--- /code/branches/newlevel2012/src/modules/towerdefense/Spielfeld Blender/Playfield.material	(revision 9096)
+++ /code/branches/newlevel2012/src/modules/towerdefense/Spielfeld Blender/Playfield.material	(revision 9096)
@@ -0,0 +1,20 @@
+material PlayField
+{
+	receive_shadows on
+	technique
+	{
+		pass
+		{
+			ambient 0.500000 0.500000 0.500000 1.000000
+			diffuse 0.640000 0.640000 0.640000 1.000000
+			specular 0.500000 0.500000 0.500000 1.000000 12.500000
+			emissive 0.000000 0.000000 0.000000 1.000000
+			texture_unit
+			{
+				texture plazfield_top.png
+				tex_address_mode wrap
+				filtering trilinear
+			}
+		}
+	}
+}
Index: /code/branches/newlevel2012/src/modules/towerdefense/Spielfeld Blender/Playfield_ME.mesh.xml
===================================================================
--- /code/branches/newlevel2012/src/modules/towerdefense/Spielfeld Blender/Playfield_ME.mesh.xml	(revision 9096)
+++ /code/branches/newlevel2012/src/modules/towerdefense/Spielfeld Blender/Playfield_ME.mesh.xml	(revision 9096)
@@ -0,0 +1,144 @@
+<mesh>
+	<submeshes>
+		<submesh material="PlayField" usesharedvertices="false">
+			<faces count="12">
+				<face v1="0" v2="1" v3="3"/>
+				<face v1="1" v2="2" v3="3"/>
+				<face v1="4" v2="5" v3="7"/>
+				<face v1="5" v2="6" v3="7"/>
+				<face v1="8" v2="9" v3="11"/>
+				<face v1="9" v2="10" v3="11"/>
+				<face v1="12" v2="13" v3="15"/>
+				<face v1="13" v2="14" v3="15"/>
+				<face v1="16" v2="17" v3="19"/>
+				<face v1="17" v2="18" v3="19"/>
+				<face v1="20" v2="21" v3="23"/>
+				<face v1="21" v2="22" v3="23"/>
+			</faces>
+			<geometry vertexcount="24">
+				<vertexbuffer positions="true" normals="true" texture_coords="1" texture_coord_dimensions_0="2">
+					<vertex>
+						<position x="10.000000" y="10.000000" z="-1.000000"/>
+						<normal x="0.000000" y="-0.000000" z="-1.000000"/>
+						<texcoord u="0.000000" v="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="10.000000" y="-10.000000" z="-1.000000"/>
+						<normal x="0.000000" y="-0.000000" z="-1.000000"/>
+						<texcoord u="1.000000" v="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-10.000000" y="-10.000000" z="-1.000000"/>
+						<normal x="0.000000" y="-0.000000" z="-1.000000"/>
+						<texcoord u="1.000000" v="0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-10.000000" y="10.000000" z="-1.000000"/>
+						<normal x="0.000000" y="-0.000000" z="-1.000000"/>
+						<texcoord u="0.000000" v="0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="10.000000" y="9.999999" z="1.000000"/>
+						<normal x="0.000000" y="0.000000" z="1.000000"/>
+						<texcoord u="1.000000" v="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-10.000000" y="10.000000" z="1.000000"/>
+						<normal x="0.000000" y="0.000000" z="1.000000"/>
+						<texcoord u="1.000000" v="0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-10.000000" y="-10.000000" z="1.000000"/>
+						<normal x="0.000000" y="0.000000" z="1.000000"/>
+						<texcoord u="0.000000" v="0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="9.999999" y="-10.000000" z="1.000000"/>
+						<normal x="0.000000" y="0.000000" z="1.000000"/>
+						<texcoord u="0.000000" v="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="10.000000" y="10.000000" z="-1.000000"/>
+						<normal x="1.000000" y="-0.000000" z="-0.000000"/>
+						<texcoord u="0.000000" v="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="10.000000" y="9.999999" z="1.000000"/>
+						<normal x="1.000000" y="-0.000000" z="-0.000000"/>
+						<texcoord u="1.000000" v="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="9.999999" y="-10.000000" z="1.000000"/>
+						<normal x="1.000000" y="-0.000000" z="-0.000000"/>
+						<texcoord u="1.000000" v="0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="10.000000" y="-10.000000" z="-1.000000"/>
+						<normal x="1.000000" y="-0.000000" z="-0.000000"/>
+						<texcoord u="0.000000" v="0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="10.000000" y="-10.000000" z="-1.000000"/>
+						<normal x="0.000000" y="-1.000000" z="0.000000"/>
+						<texcoord u="0.000000" v="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="9.999999" y="-10.000000" z="1.000000"/>
+						<normal x="0.000000" y="-1.000000" z="0.000000"/>
+						<texcoord u="1.000000" v="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-10.000000" y="-10.000000" z="1.000000"/>
+						<normal x="0.000000" y="-1.000000" z="0.000000"/>
+						<texcoord u="1.000000" v="0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-10.000000" y="-10.000000" z="-1.000000"/>
+						<normal x="0.000000" y="-1.000000" z="0.000000"/>
+						<texcoord u="0.000000" v="0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-10.000000" y="-10.000000" z="-1.000000"/>
+						<normal x="-1.000000" y="0.000000" z="0.000000"/>
+						<texcoord u="0.000000" v="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-10.000000" y="-10.000000" z="1.000000"/>
+						<normal x="-1.000000" y="0.000000" z="0.000000"/>
+						<texcoord u="1.000000" v="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-10.000000" y="10.000000" z="1.000000"/>
+						<normal x="-1.000000" y="0.000000" z="0.000000"/>
+						<texcoord u="1.000000" v="0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-10.000000" y="10.000000" z="-1.000000"/>
+						<normal x="-1.000000" y="0.000000" z="0.000000"/>
+						<texcoord u="0.000000" v="0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="10.000000" y="9.999999" z="1.000000"/>
+						<normal x="0.000000" y="1.000000" z="0.000000"/>
+						<texcoord u="0.000000" v="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="10.000000" y="10.000000" z="-1.000000"/>
+						<normal x="0.000000" y="1.000000" z="0.000000"/>
+						<texcoord u="1.000000" v="1.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-10.000000" y="10.000000" z="-1.000000"/>
+						<normal x="0.000000" y="1.000000" z="0.000000"/>
+						<texcoord u="1.000000" v="0.000000"/>
+					</vertex>
+					<vertex>
+						<position x="-10.000000" y="10.000000" z="1.000000"/>
+						<normal x="0.000000" y="1.000000" z="0.000000"/>
+						<texcoord u="0.000000" v="0.000000"/>
+					</vertex>
+				</vertexbuffer>
+			</geometry>
+		</submesh>
+	</submeshes>
+</mesh>